#ifndef BALL_HPP
#define BALL_HPP

#include <list>
#include <oiran/linda/graphics.hpp>
#include "defs.hpp"


class ball_t
{
public:
	enum { orbit_size = 10 };
	typedef std::list<vector_type> orbit_list_type;

	vector_type o;
	vector_type p;
	vector_type direction;
	double speed;

	void init(const vector_type& v);
	void update();
	void draw(oiran::linda::graphics_t& g);
	void push_orbit(const vector_type& v);

private:
	orbit_list_type M_orbit[orbit_size];
};


#endif // BALL_HPP
