#ifndef DEFS_HPP
#define DEFS_HPP

#include <oiran/rita/vector.hpp>


typedef oiran::rita::vector_t<double, 2> vector_type;

const char* const name = "bb";
const int framerate = 50;
const int width = 462;
const int height = 260;

const unsigned int front_color = 0xffffff;
const unsigned int sub_color = 0xff0000;
const unsigned int background_color = 0x2b2b2b;

const int block_size = 12;
const int field_width = 20;
const int field_height = 15;
const int game_offset_x = (width - field_width * block_size) / 2;
const int game_offset_y = (height - field_height * block_size) / 2;

const int max_stage = 99;
const double pad_y = field_height * block_size + 1;
const double pad_width = field_width * block_size / 8;
const int max_life = 3;

const int number_of_blocks = 2;
enum {
	wall = 1,
	normal
};

const int image_size = 2;
const char* const image_files[] = {
	"res/wall.bmp",
	"res/normal.bmp",
};


#endif // DEFS_HPP
