#ifndef OIRAN_LINDA_MODULE_HPP
#define OIRAN_LINDA_MODULE_HPP

#include <SDL.h>
#include <oiran/singleton.hpp>

namespace oiran { namespace linda {


	// core module.
	/*
	 * this class intializes SDL in constructor and shuts down SDL in
	 * destructor so instantiate this class earlier than others.
	 */
	class module_t : public singleton_t<module_t>
	{
	public:
		static const Uint32 default_framerate;

		module_t();
		~module_t();

		void screen(int width, int height);
		bool handle_event();
		void wait();

		void title(const char* value);
		void framerate(Uint32 value);
		void cursor();
		void no_cursor();

		int width() const { return M_screen_width; }
		int height() const { return M_screen_height; }
		float framerate() const { return M_framerate; }

	private:
		bool _handle_event();
		void _wait();
		void _calculate_framerate();

	private:
		int M_screen_width;
		int M_screen_height;
		float M_framerate;
		Uint32 M_setted_framerate;
		Uint32 M_last_update_time;
		Uint32 M_last_calculate_time;
		Uint32 M_frame_count;
	};


}} // namespace oiran::linda.

#endif // OIRAN_LINDA_MODULE_HPP
